function foxfm_team(doc)
{
	try
	{
		if(foxfm_isOFMDomainTeam(doc.location.href)) 
		{
			infoMessage(2, "foxfm_team(): started");

			// get all tables --> tag: 'table'
			var tbl = doc.getElementsByTagName("table");
			// get table of the team --> look for "Pos" and "Spielername"
			var teamTableIndex = findTable(tbl, "Pos", "Spielername");
			if(teamTableIndex >= 0)
			{
				var headerRow = findRow(tbl[teamTableIndex], "Pos", "Spielername");
				var lvlCol = parseInt(findColumn(tbl[teamTableIndex].rows[headerRow].cells, "St"));
				var awpCol;
				awpCol = parseInt(findColumn(tbl[teamTableIndex].rows[headerRow].cells, "Rel"));
				if(awpCol >= 0) 
				{
					// alert("calling: addCurrLvlAwpsDiffNextLvl(" + headerRow + ", " + awpCol + ", " + (awpCol+1) + ", " + (awpCol+2) + ", " + (awpCol+3) + ")");
					addCurrLvlAwpsDiffNextLvl(tbl[teamTableIndex], headerRow, null, lvlCol, null, null, awpCol, (awpCol+1), (awpCol+2), (awpCol+3));
				} // if()
			}			
			
			foxfm_team_addContractCosts(doc);
			foxfm_team_contractDurationWarning(doc);
			foxfm_team_contractDurationRenewAdvice(doc);	
			foxfm_team_warningOnPlayerAge(doc);
			
			// set max width of second column of the contract column
			var aContractDuration = foxfm_team_getContractDurationCol2(doc);
			for(var i=0; i<aContractDuration.length; i++)
			{
				aContractDuration[i].width = "30";
			}
			
			// get all tables of the OFM-Team page
			var aTables = doc.evaluate( '//./table', doc.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );

			// set width of all table of the OFM-Team page
			if(aTables.snapshotLength)
			{
				for(var i=0; i<aTables.snapshotLength; i++)
				{
					aTables.snapshotItem(i).width = "92%";
				}
			}
			
			// seth the width of the team table separatly to 100%
			foxfm_team_getTeamTable(doc).width = "100%";
		}		
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_team_getTeamTable(document)
{
	var tblTeam = null;
	try
	{
		infoMessage(3, "foxfm_team_getTeamTable(): started");

		var xpathresult = getXpathResult(document, '//./table/tbody/tr/td/a/.[@href="?orderby=2"]');
//		var xpathresult = getXpathResult(document, "//table/tbody/tr/td/a[contains(@href, 'orderby=2')]");
//		var xpathresult = getXpathResult(document, '//./table/tbody/tr/td/a/.[@href="http://www.onlinefussballmanager.de/010_mannschaft/spieler.php?orderby=2"]');

		if(xpathresult.snapshotLength==1)
		{
			tblTeam = get1stOccurenceOfParentNode(xpathresult.snapshotItem(0), "table");
		} else {
			errorMessage("foxfm_team_getTeamTable(): Could not determine the table containing the team.");
		}
	} catch (e) {
		errorMessage(e);
	}
	return tblTeam;
}

function foxfm_team_addContractCosts(document)
{
	try
	{
		infoMessage(3, "foxfm_team_addContractCosts(): started");

		var addContractCosts	= prefBranchOFMFunctionSettings.get("team.addcontractcosts");

		if(addContractCosts)
		{
			var addContractCostsRenewNow	= prefBranchOFMFunctionSettings.get("team.addcontractcostsrenewnow");
			var addContractCostsRenewLater	= prefBranchOFMFunctionSettings.get("team.addcontractcostsrenewlater");
			
			if((addContractCostsRenewNow || addContractCostsRenewLater))
			{
				var durationColNo 			= foxfm_team_getContractDurationColNo(document);
				var durationColumn			= foxfm_team_getContractDurationCol(document);
				
				if(durationColNo && durationColumn)
				{
					var tblTeam 				= foxfm_team_getTeamTable(document);
					var aTeamWages				= foxfm_team_getArrayOfWages(document);
					var aOFMWages				= foxfm_getArrayOfOFMWages(document);
					var aStrengths				= foxfm_team_getArrayOfCurrStr(document);
					var aAWPs					= foxfm_team_getArrayOfAWPs(document);
					var aAges					= foxfm_team_getAgeCol(document);		
					var colNoContractCostNow	= durationColNo;
					var colNoContractCostLater	= durationColNo;
					
					if(addContractCostsRenewNow)
					{
						// add header and footer
						addCell(tblTeam, 0, colNoContractCostNow, "", getLocale("ofm.team.contractcostsrenewnow"), "top", "center", "", "70");
						addCell(tblTeam, durationColumn.length+1, colNoContractCostNow, null, "", "", "right", "#49a084", "");
						colNoContractCostLater++;
					}
					if(addContractCostsRenewLater)
					{
						// add header and footer
						addCell(tblTeam, 0, colNoContractCostLater, "", getLocale("ofm.team.contractcostsrenewlater"), "top", "center", "", "90");
						addCell(tblTeam, durationColumn.length+1, colNoContractCostLater, null, "", "", "right", "#49a084", "");
					}
					
					// iterate through team table using length of the duration column content
					for(var i=0; i<durationColumn.length; i++)
					{
						if(addContractCostsRenewNow && getNumberFromCell(aAges[i])<36)
						{
							var currStrLvl				= aStrengths[i];
							var currStrLvlWage			= aOFMWages[currStrLvl-1];
							var incomeCostsRenewNow		= foxfm_team_getIncomeCosts(36, currStrLvlWage);
							
							addCell(tblTeam, i+1, colNoContractCostNow, "",  insertThousendDevider(incomeCostsRenewNow) + " \u20ac", "", "right", "", "");
						} else {
							addCell(tblTeam, i+1, colNoContractCostNow, "",  "N/A", "", "right", "", "");
						}
						if(addContractCostsRenewLater)
						{
							var currDurationLeft		= getNumberFromCell(durationColumn[i])+1;
							var currWage				= aTeamWages[i];
							var realStrLvl				= getStrengthLevel(aAWPs[i]);
							var realStrLvlWage			= aOFMWages[realStrLvl-1];
							var incomeCostsLeftDuration	= foxfm_team_getIncomeCosts(currDurationLeft, currWage);
							var incomeCostsAfterDuration=0;
							if(getNumberFromCell(aAges[i])<36)
							{
								incomeCostsAfterDuration= foxfm_team_getIncomeCosts(36-currDurationLeft, realStrLvlWage);
							}
							var incomeCostsRenewLater	= incomeCostsLeftDuration + incomeCostsAfterDuration;

							addCell(tblTeam, i+1, colNoContractCostLater, "", insertThousendDevider(incomeCostsRenewLater) + " \u20ac", "", "right", "", "");
						}
					}
				} else {
					errorMessage("foxfm_team_addContractCosts(): " + getLocale("ofm.team.error.onaddcontractcosts"));
				}
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_team_getIncomeCosts(duration, wage)
{
	var incomecosts = new Number();
	try
	{
		infoMessage(4, "foxfm_team_getIncomeCosts(): started(dur, wage): " + duration + ", " + wage);

		if(!isNaN(duration) && !isNaN(wage))
		{
			incomecosts = duration * wage;
			infoMessage(4, "foxfm_team_getIncomeCosts(): duration( " + duration + " ) * wage( " + wage + ") = " + incomecosts);
		} else  {
			errorMessage("foxfm_team_getIncomeCosts(): " + getLocale("ofm.team.error.onaddcontractcosts"));
		}
	} catch (e) {
		errorMessage(e);
	}
	return incomecosts;
}

function foxfm_team_contractDurationWarning(document)
{
	try
	{
		infoMessage(3, "foxfm_team_contractDurationWarning(): started");

		var addContractDurationWarning	= prefBranchOFMFunctionSettings.get("team.addcontractdurationwarning");

		if(addContractDurationWarning)
		{
			var contractDurationWarningLevel	= prefBranchOFMFunctionSettings.get("team.contractdurationwarninglevel");
			infoMessage(3, "foxfm_team_contractDurationWarning(): contract duration warning level: " + contractDurationWarningLevel);
			
			var durationColumn 					= foxfm_team_getContractDurationCol(document);
			if(durationColumn)
			{
				for(var i=0; i<durationColumn.length; i++)
				{
					if((getNumberFromCell(durationColumn[i])<contractDurationWarningLevel))
					{					
						var color	= prefBranchOFMFunctionSettings.get("team.contractdurationwarningcolor");
						durationColumn[i].style.backgroundColor = color;	
					}
				}
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_team_warningOnPlayerAge(document)
{
	try
	{
		infoMessage(3, "foxfm_team_warningOnPlayerAge(): started");

		var addWarnOnPlayerAge		= prefBranchOFMFunctionSettings.get("team.addwarnonplayerage");

		if(addWarnOnPlayerAge)
		{			
			var aAge				= foxfm_team_getAgeCol(document);		
			infoMessage(3, "foxfm_team_warningOnPlayerAge(): Number of found contracts/players: " + aAge.length);
			if(aAge)
			{			
				var warningAge		= getNumberFromString(prefBranchOFMFunctionSettings.get("team.warningage"));
		
				for(var i=0; i<aAge.length; i++)
				{		
					currAge			= getNumberFromCell(aAge[i]);
					infoMessage(3, "foxfm_team_warningOnPlayerAge(): current age: " + currAge);
					var matchday	= getNumberFromString(prefBranchOFMFunctionSettings.get("team.warnonplayeragematchday"));
					if(currAge >= warningAge && gMatchday.day >= matchday)
					{
						var color	= prefBranchOFMFunctionSettings.get("team.warnonplayeragecolor");
						aAge[i].style.backgroundColor = color;
					}
				}
			}
		}
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_team_getContractDurationCol(document)
{
	var aDurations = null;
	try
	{
		infoMessage(4, "foxfm_team_getContractDurationCol(): started");		
		
		var elementTblHdDurations = document.evaluate( '//./table/tbody/tr/td/a/.[@href="?orderby=10"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );

		var parentTable = get1stOccurenceOfParentNode(elementTblHdDurations.snapshotItem(0), "table");
		if(parentTable)
		{
			var parentCell					= get1stOccurenceOfParentNode(elementTblHdDurations.snapshotItem(0), "td");
			var columnNoOfContractDuration	= getNoOfColumn(parentCell);
			var aColumn 					= getColumnContent(parentTable, columnNoOfContractDuration);
			aDurations						= aColumn.slice(1, aColumn.length-2);
		}
		infoMessage(4, "foxfm_team_getContractDurationCol: contract durations: " + aDurations + "; length: " + aDurations.length);
	} catch (e) {
		errorMessage(e);
	}
	return aDurations;
}

function foxfm_team_getContractDurationCol2(document)
{
	var aDurations = null;
	try
	{
		infoMessage(4, "foxfm_team_getContractDurationCol(): started");		
		
		var elementTblHdDurations = document.evaluate( '//./table/tbody/tr/td/a/.[@href="?orderby=10"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );

		var parentTable = get1stOccurenceOfParentNode(elementTblHdDurations.snapshotItem(0), "table");
		if(parentTable)
		{
			var parentCell					= get1stOccurenceOfParentNode(elementTblHdDurations.snapshotItem(0), "td");
			var columnNoOfContractDuration	= getNoOfColumn(parentCell);
			var aColumn 					= getColumnContent(parentTable, columnNoOfContractDuration+1);
			aDurations						= aColumn.slice(1, aColumn.length-1);
		}
		infoMessage(4, "foxfm_team_getContractDurationCol: contract durations: " + aDurations + "; length: " + aDurations.length);
	} catch (e) {
		errorMessage(e);
	}
	return aDurations;
}

function foxfm_team_getContractDurationColNo(document)
{
	var durationColNo = null;
	try
	{
		infoMessage(4, "foxfm_team_getContractDurationColNo(): started");		
		
		var xpathresult = getXpathResult(document, '//./table/tbody/tr/td/a/.[@href="?orderby=10"]');

		if(xpathresult.snapshotLength==1)
		{
			var parentCell	= get1stOccurenceOfParentNode(xpathresult.snapshotItem(0), "td");
			durationColNo	= getNoOfColumn(parentCell);
		} else {
			errorMessage("foxfm_team_getContractDurationColNo(): Could not determine the number of the column containing the remaining contract duration.");
		}

		infoMessage(4, "foxfm_team_getContractDurationColNo: contract duration column number: " + durationColNo);
	} catch (e) {
		errorMessage(e);
	}
	return durationColNo;
}

function foxfm_team_contractDurationRenewAdvice(document)
{
	try
	{
		infoMessage(3, "foxfm_team_contractDurationRenewAdvice(): started");

		var addContractDurationRenewAdvice	= prefBranchOFMFunctionSettings.get("team.addcontractdurationrenewadvice");

		if(addContractDurationRenewAdvice)
		{
			var linksContractRenew = foxfm_team_getLinksContractDurationRenew(document);
			infoMessage(3, "foxfm_team_contractDurationRenewAdvice(): Number of found contracts/players: " + linksContractRenew.length);
			if(linksContractRenew.length)
			{
				var aTeamWages		= foxfm_team_getArrayOfWages(document);
				var aOFMWages		= foxfm_getArrayOfOFMWages(document);
				var aStrengths		= foxfm_team_getArrayOfCurrStr(document);
				var durationColumn	= foxfm_team_getContractDurationCol(document);
				var aAWPs			= foxfm_team_getArrayOfAWPs(document);
				var maxOFMContractDuration = 35;
					
				for(var i=0; i<linksContractRenew.length; i++)
				{
					var color				= null;
					var currWage			= aTeamWages[i];
					var currStrLvl			= aStrengths[i];					
					var realStrLvl			= getStrengthLevel(aAWPs[i]);
					var currDuration		= getNumberFromCell(durationColumn[i]);
					
					if(currDuration < maxOFMContractDuration)
					{
					
						var addContractDurationRenewOnNoWageChange	= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonnoincomechanges");
						if(addContractDurationRenewOnNoWageChange)
						{
							var strLvlWage		= aOFMWages[currStrLvl-1];
							var leftDuration	= getNumberFromString(prefBranchOFMFunctionSettings.get("team.contractdurationrenewonnoincomechangesleftduration"));
							if(currWage == strLvlWage && currDuration <= leftDuration)
							{
								color	= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonnoincomechangescolor");
							}
						}
						
						var addContractDurationRenewOnPossibleUpgrade	= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonpossibleupgrade");
						if(addContractDurationRenewOnPossibleUpgrade)
						{
							var AWPsNextLvl			= getAWPsOfLevel(realStrLvl+1);
							var diffAWPsToNextLvl	= AWPsNextLvl-aAWPs[i];
							var awpDiff				= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonpossibleupgradeawpdiff");
							infoMessage(3, "foxfm_team_contractDurationRenewAdvice(): 'AWPs': " + aAWPs[i] + " - 'AWPs next level': " + AWPsNextLvl + " = " + diffAWPsToNextLvl + " < " + awpDiff + "?");
							if(diffAWPsToNextLvl < awpDiff)
							{
								color	= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonpossibleupgradecolor");
							}
						}				

						var addContractDurationRenewOnUpgrade	= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonupgrade");
						if(addContractDurationRenewOnUpgrade)
						{					
							if(currStrLvl != realStrLvl)
							{
								color	= prefBranchOFMFunctionSettings.get("team.contractdurationrenewonupgradecolor");
							}
						}

						parentCell = get1stOccurenceOfParentNode(linksContractRenew[i], "td");
						if(color && parentCell)
						{				
							parentCell.style.backgroundColor = color;
						}
					}
				}
			} else {
				errorMessage("Could not find any contracts to renew!");
			}		
		}
	} catch (e) {
		errorMessage(e);
	}
}

function foxfm_team_getLinksContractDurationRenew(document)
{
	var aContractDurationRenew = null;
	try
	{
		infoMessage(4, "foxfm_team_getLinksContractDurationRenew(): started");
		
		var elementsContractDurationRenew = document.evaluate( '//./font/.[@color="#2173a3"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
		
		aContractDurationRenew = new Array(elementsContractDurationRenew.snapshotLength);
		for(var i=0; i<elementsContractDurationRenew.snapshotLength; i++)
		{
			aContractDurationRenew[i]	= elementsContractDurationRenew.snapshotItem(i);
		}
	} catch (e) {
		errorMessage(e);
	}
	return aContractDurationRenew;
}

function foxfm_team_getArrayOfAWPs(document)
{
	var aAWPs = null;
	try
	{
		infoMessage(4, "foxfm_team_getArrayOfAWPs(): started");
		
		var elementsAWPs = document.evaluate( '//./table/tbody/tr/td/font/.[@color="#005709"]/b', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
		
		aAWPs = new Array(elementsAWPs.snapshotLength);
		infoMessage(4, "foxfm_team_getArrayOfAWPs(): aAWPs.length: " + elementsAWPs.snapshotLength);

		for(var i=0; i<elementsAWPs.snapshotLength; i++)
		{
			aAWPs[i]	= getNumberFromString(elementsAWPs.snapshotItem(i).innerHTML);
		}
		infoMessage(4, "foxfm_team_getArrayOfAWPs: AWPs: " + aAWPs);
	} catch (e) {
		errorMessage(e);
	}
	return aAWPs;
}

function foxfm_team_getArrayOfCurrStr(document)
{
	var aStrengths = null;
	try
	{
		infoMessage(4, "foxfm_team_getArrayOfCurrStr(): started");
		
		var elementsStrengths = document.evaluate( '//./table/tbody/tr/td/font/.[@color="#1b518f"]/b', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
		
		aStrengths = new Array(elementsStrengths.snapshotLength);
		infoMessage(4, "foxfm_team_getArrayOfCurrStr(): aStrengths.length: " + elementsStrengths.snapshotLength);

		for(var i=0; i<elementsStrengths.snapshotLength; i++)
		{
			aStrengths[i]	= getNumberFromString(elementsStrengths.snapshotItem(i).innerHTML);
		}
		infoMessage(4, "foxfm_team_getArrayOfCurrStr: Current Strengths: " + aStrengths);
	} catch (e) {
		errorMessage(e);
	}
	return aStrengths;
}

function foxfm_team_getAgeCol(document)
{
	var aAge = null;
	try
	{
		infoMessage(4, "foxfm_team_getAgeCol(): started");
		
		var elementTblHdAge = document.evaluate( '//./table/tbody/tr/td/a/.[@href="?orderby=3"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );

		// get the table containing the age of players
		var parentTable = get1stOccurenceOfParentNode(elementTblHdAge.snapshotItem(0), "table");		
		if(parentTable)
		{
			var ageColNo	= foxfm_team_getAgeColNo(document);
			var aColumn		= getColumnContent(parentTable, ageColNo);
			aAge			= new Array(aColumn.length);
			for(var i=0; i<aColumn.length; i++)
			{
				aAge[i] = aColumn[i];
			}
			aAge	= aAge.slice(1, aAge.length-1);
		}
		infoMessage(4, "foxfm_team_getAgeCol(): column containing the age: " + aAge);
	} catch (e) {
		errorMessage(e);
	}
	return aAge;
}

function foxfm_team_getAgeColNo(document)
{
	var ageColNo = null;
	try
	{
		infoMessage(4, "foxfm_team_getAgeColNo(): started");
		
		var xpathresult = document.evaluate( '//./table/tbody/tr/td/a/.[@href="?orderby=3"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );

		if(xpathresult.snapshotLength==1)
		{
			var parentCell	= get1stOccurenceOfParentNode(xpathresult.snapshotItem(0), "td");
			ageColNo	= getNoOfColumn(parentCell);
		} else {
			errorMessage("foxfm_team_getAgeColNo(): Could not determine the number of the column containing the age.");
		}

		infoMessage(4, "foxfm_team_getAgeColNo(): number of the column containing the age: " + ageColNo);
	} catch (e) {
		errorMessage(e);
	}
	return ageColNo;
}

function foxfm_team_getArrayOfWages(document)
{
	var aWages = null;
	try
	{
		infoMessage(4, "foxfm_team_getArrayOfWages(): started");
		var elementTblHdWages	= document.evaluate( '//./table/tbody/tr/td/a/.[@href="?orderby=9"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
		var parentTable			= get1stOccurenceOfParentNode(elementTblHdWages.snapshotItem(0), "table");
		if(parentTable)
		{
			var parentCell		= get1stOccurenceOfParentNode(elementTblHdWages.snapshotItem(0), "td");
			var wagesColNo		= getNoOfColumn(parentCell);
			var aColumn			= getColumnContent(parentTable, wagesColNo);
			aWages				= new Array(aColumn.length);
			for(var i=0; i<aColumn.length; i++)
			{
				aWages[i] = getNumberFromCell(aColumn[i]);
				infoMessage(4, "foxfm_team_getArrayOfWages: wage: " + aWages[i]);
			}
			aWages	= aWages.slice(1, aWages.length-1);
		}
		infoMessage(4, "foxfm_team_getArrayOfWages: number of the column containing the wages: " + aWages);
	} catch (e) {
		errorMessage(e);
	}
	return aWages;
}

function foxfm_getArrayOfOFMWages(document)
{
	var aWages = null;
	try
	{
		infoMessage(4, "foxfm_getArrayOfOFMWages(): started");
		
		var elementTblHdWages = document.evaluate( '//./table/tbody/tr/td/a/.[@href="?orderby=9"]', document.documentElement, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
		var parentTable = get1stOccurenceOfParentNode(elementTblHdWages.snapshotItem(0), "table");
		if(parentTable)
		{
			var parentCell		= get1stOccurenceOfParentNode(elementTblHdWages.snapshotItem(0), "td");
			var wagesColNo		= getNoOfColumn(parentCell);
			var tblHdrCellWage	= parentTable.rows[0].cells[wagesColNo];
			var strWages		= tblHdrCellWage.innerHTML.replace(/\./gm, "");
			var aLvlToWages		= strWages.match(/\d+ :: \d+/g);
			infoMessage(4, "foxfm_getArrayOfOFMWages: " + aLvlToWages);
			aWages				= new Array(aLvlToWages.length);
			
			for(var i=0; i<aLvlToWages.length; i++)
			{
				infoMessage(4, "foxfm_getArrayOfOFMWages: " + aLvlToWages[i].match(/\d+/g));

				aWages[i]	= aLvlToWages[i].match(/\d+/g)[1];
			}
		}
		infoMessage(4, "foxfm_getArrayOfOFMWages: " + aWages);
	} catch (e) {
		errorMessage(e);
	}
	return aWages;
}
